unit MHaupt;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, UdvList,MVokabel, ExtCtrls, Buttons, UVokabeleingabe
  ;


type TForm1 = class(TForm)
    Lbl1: TLabel;
    Eddeutsch: TEdit;
    ListBox1: TListBox;
    BtnachVorne: TButton;
    BtNachHinten: TButton;
    BtAnfangListe: TButton;
    BtEndeListe: TButton;
    Bevel1: TBevel;
    BtEinfuegen: TBitBtn;
    BtDelete: TBitBtn;
    Edenglisch: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Bevel2: TBevel;
    Btsortieredeutsch: TButton;
    Btsortiereenglisch: TButton;
    EdAnzahl: TEdit;
    BtZufall: TButton;
    EdLaufzeit: TEdit;
    Label3: TLabel;
    BtBubble1: TButton;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    procedure BtAnfangListeClick(Sender: TObject);
    procedure BtnachVorneClick(Sender: TObject);
    procedure BtNachHintenClick(Sender: TObject);
    procedure BtEndeListeClick(Sender: TObject);
    procedure BtCloseClick(Sender: TObject);
    procedure BtDeleteClick(Sender: TObject);
    procedure BtEinfuegenClick(Sender: TObject);
    procedure BtsortieredeutschClick(Sender: TObject);
    procedure BtsortiereenglischClick(Sender: TObject);
    procedure BtZufallClick(Sender: TObject);
    procedure BtBubble1Click(Sender: TObject);

    private
        hListe: TdvList;
        deutsch:boolean;
        procedure Anfangswerte;
        procedure Anzeigen;
        procedure fuege_ein(neu :TVokabel);
        procedure sortiere_durch_einfuegen;
        procedure erzeuge_zufallsvokabeln;
end;

var Form1: TForm1;
    inhalt : TVokabel;
    eingabe :TFVokabeleingabe;
    inh  : string;

implementation

{$R *.DFM}

(*************************** private Methoden ****************************)

procedure TForm1.Anfangswerte;
begin
  inhalt :=TVokabel.create;
  inhalt.setdeutsch('Vater');
  inhalt.setenglisch('father');
  fuege_ein(inhalt);
  inhalt :=TVokabel.create;
  inhalt.setdeutsch('Mutter');
  inhalt.setenglisch('mother');
  fuege_ein(inhalt);;
  inhalt :=TVokabel.create;
  inhalt.setdeutsch('Kind');
  inhalt.setenglisch('child');
  fuege_ein(inhalt);;
end;

procedure TForm1.Anzeigen;
var merk, aktuell: TVokabel;
begin
if deutsch then
   caption := 'Deutsch sortiert'
else
   caption := 'Englisch sortiert';
Listbox1.Items.Clear;
if not hliste.isempty then begin
    Merk := TVokabel(hListe.GetElement);
    Eddeutsch.text:=merk.Getdeutsch;
    Edenglisch.text := merk.Getenglisch ;
    hListe.first;
    while not hListe.islast do begin
      aktuell := TVokabel(hListe.GetElement);
      hListe.next;
      ListBox1.Items.Add (aktuell.getdeutsch +' - ' +aktuell.getenglisch);
    end;
    aktuell := TVokabel(hListe.GetElement);
    ListBox1.Items.Add (aktuell.getdeutsch +' - ' +aktuell.getenglisch);
    hliste.first;
    aktuell := TVokabel (hliste.GetElement);

    while merk.Getdeutsch <> aktuell.Getdeutsch do begin
       hliste.next ;
       aktuell := TVokabel(hListe.GetElement)
    end
  end (* of if*)
end; {procedure}

procedure TForm1.fuege_ein (neu:TVokabel);
begin
   If hliste.isempty then
      hliste.add(neu)
   else
      if deutsch then begin
         hliste.first;
         while ( TVokabel(hliste.getelement).getdeutsch < neu.getdeutsch )
               and not hliste.islast do
           hliste.next;
         if hliste.islast then
            if TVokabel(hliste.getelement).getdeutsch < neu.getdeutsch then
               hliste.add(neu)
            else
               hliste.insert(neu)
         else (* nicht am Ende *)
            hliste.insert(neu)
       end (* of if deutsch *)
      else (* englisch einfuegen *) begin
         hliste.first;
         while (TVokabel(hliste.getelement).getenglisch < neu.getenglisch)
               and not hliste.islast do
           hliste.next;
         if hliste.islast then
            if TVokabel(hliste.getelement).getenglisch < neu.getenglisch then
               hliste.add(neu)
            else
               hliste.insert(neu)
         else
            hliste.insert(neu)
       end (* of if deutsch *)

end;

procedure TForm1.sortiere_durch_einfuegen;
var hilfsliste : TdvList;
begin
   (* kopiere in hilfsliste *)
   hilfsliste := TdvList.create;
   hliste.first;
   while not hliste.isempty do begin
      hilfsliste.insert(hliste.getelement);
      hliste.delete
   end;

   (* fuege aus hilfsliste einzeln wieder ein *)
   hilfsliste.first;
   while not hilfsliste.isempty do begin
      fuege_ein(TVokabel(hilfsliste.getelement));
      hilfsliste.delete
   end;
end;

procedure TForm1.erzeuge_zufallsvokabeln;
var i:Integer;
begin
   (* lsche *)
   hliste.first;
   while not hliste.isempty do  begin
      TVokabel(hliste.getelement).destroy ;
      hliste.delete
   end;

   (* fuege aus hilfsliste einzeln wieder ein *)
   For i := 1 to StrToInt (EdAnzahl.text) do begin
      inhalt := TVokabel.create;
      inhalt.setdeutsch(IntToStr(random(1000000)));
      inhalt.setenglisch(IntToStr(random(1000000)));
      fuege_ein(TVokabel(inhalt));
   end;
end;


(***********************  Ereignismethoden  ***********************************)

procedure TForm1.FormCreate(Sender: TObject);
begin
  Form1.hListe := TdvList.Create;
  deutsch:=true;
  Btsortieredeutsch.enabled := false;
  Btsortiereenglisch.enabled := true;
  Anfangswerte;
  Anzeigen;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  hListe.last;
  while not hListe.isempty do begin
    hListe.GetElement.Destroy;
    hListe.Delete;
  end;
  hListe.free
end;

procedure TForm1.BtAnfangListeClick(Sender: TObject);
begin
  hListe.first;
  anzeigen;
end;

procedure TForm1.BtnachVorneClick(Sender: TObject);
begin
    hListe.previous;
    anzeigen;
end;

procedure TForm1.BtNachHintenClick(Sender: TObject);
begin
    hListe.next;
    anzeigen;
end;

procedure TForm1.BtEndeListeClick(Sender: TObject);
begin
  hListe.last;
  anzeigen;
end;


procedure TForm1.BtCloseClick(Sender: TObject);
begin
  close
end;



procedure TForm1.BtDeleteClick(Sender: TObject);
begin
hliste.delete;
anzeigen;

end;

procedure TForm1.BtEinfuegenClick(Sender: TObject);
begin
  Eingabe := TFVokabeleingabe.create(Form1) ;
  Eingabe.showmodal;
  if eingabe.eddeutsch.text <> '' then
   begin
    inhalt :=TVokabel.create;
    inhalt.setdeutsch(eingabe.eddeutsch.text);
    inhalt.setenglisch(eingabe.edenglisch.text);
    fuege_ein(inhalt);;
   end;
  eingabe.free;
  anzeigen 
end;

procedure TForm1.BtsortieredeutschClick(Sender: TObject);
var  Startzeit,Laufzeit: TDateTime;
     Hour, Min, Sec, MSec: Word;
begin
   deutsch := true;
   Btsortieredeutsch.enabled := false;
   Btsortiereenglisch.enabled := true;
   caption := 'Deutsch sortiert' ;
   Startzeit:=Now;
   sortiere_durch_einfuegen;
   Laufzeit := Now-Startzeit;
   DecodeTime(Laufzeit, Hour, Min, Sec, MSec);
   MSec:=MSec+(Sec*1000);
   EdLaufzeit.text := IntToStr(MSec);
   anzeigen
end;

procedure TForm1.BtsortiereenglischClick(Sender: TObject);
var  Startzeit,Laufzeit: TDateTime;
     Hour, Min, Sec, MSec: Word;
begin
   deutsch := false;
   Btsortieredeutsch.enabled := true;
   Btsortiereenglisch.enabled := false;
   caption := 'Englisch sortiert';
   Startzeit:=Now;
   sortiere_durch_einfuegen;
   Laufzeit := Now-Startzeit;
   DecodeTime(Laufzeit, Hour, Min, Sec, MSec);
   MSec:=MSec+(Sec*1000);
   EdLaufzeit.text := IntToStr(MSec);
   anzeigen
end;

procedure TForm1.BtZufallClick(Sender: TObject);
begin
   erzeuge_zufallsvokabeln ;
   anzeigen
end;

procedure TForm1.BtBubble1Click(Sender: TObject);
var getauscht : Boolean;
    aktuelleVokabel, naechsteVokabel : TVokabel;
    Startzeit,Laufzeit: TDateTime;
     Hour, Min, Sec, MSec: Word;
begin
   startzeit := now;
   repeat
      getauscht := false;
      hliste.first;
      while not hliste.islast do begin
         aktuelleVokabel := TVokabel(hliste.getelement);
         hliste.next;
         naechsteVokabel := TVokabel(hliste.getelement);
         if UpperCase(aktuelleVokabel.GetDeutsch) >
            Uppercase(naechsteVokabel.GetDeutsch) then begin
            (* Tauschen *)
            hliste.delete;
            hliste.previous;
            hliste.insert(naechsteVokabel);
            hliste.next;
            getauscht := true
         end (* of if *)
      end (* of while *)
   until getauscht = false;
   laufzeit := now-startzeit;
   DecodeTime(Laufzeit, Hour, Min, Sec, MSec);
   MSec:=MSec+(Sec*1000);
   EdLaufzeit.text := IntToStr(MSec);
   anzeigen
end;

end.
